<script setup>
import PageTitle from "@/components/global/PageTitle.vue";
import RestrictedPageWrapper from "@/components/page/wrappers/RestrictedPageWrapper.vue";
import { SessionUser } from "@/components/session/token/SessionUser.vue";
import { useRouter } from 'vue-router'
import { ref } from 'vue';
import { ConfigurationSelectOption } from "@/components/displays/superuser/configuration/ConfigurationSelectObject.vue";
import ConfigurationSubPageWrapper
  from "@/views/dashboards/superUserDashboard/configuration/ConfigurationSubPageWrapper.vue";
import ConfigurationCategory from "@/components/displays/superuser/configuration/ConfigurationCategory.vue";
import ConfigurationSwitch from "@/components/displays/superuser/configuration/ConfigurationSwitch.vue";
import ConfigurationSelect from "@/components/displays/superuser/configuration/ConfigurationSelect.vue";
import ConfigurationSecretKey from "@/components/displays/superuser/configuration/ConfigurationSecretKey.vue";
import ConfigurationInput from "@/components/displays/superuser/configuration/ConfigurationInput.vue";
import ConfigurationInputNumber from "@/components/displays/superuser/configuration/ConfigurationInputNumber.vue";
import Swal from "sweetalert2";

// Get the department from the route
const router = useRouter()

const enabled = ref(false);
const module_config = ref([]);

const getEnabled = async () => {
  await SessionUser.superUser.modules.xlvask.config.enabled.get().then((response) => {
    enabled.value = response.data.data;
  }).catch((error) => {
    console.log(error);
  });
};

const getModuleConfig = async () => {
  await SessionUser.superUser.modules.xlvask.config.get_all().then((response) => {
    let tmp_module_config = response.data.data;
    let tmp_module_config_array = [];
    for (const [key, value] of Object.entries(tmp_module_config)) {
      console.log(`${value.variable}: ${value.value}`);
      tmp_module_config_array.push({
        variable: value.variable,
        value: value.value,
      });
    }
    module_config.value = tmp_module_config_array;
    console.log(module_config.value);
  }).catch((error) => {
    console.log(error);
  });
};

const getModuleConfigValue = (variable) => {
  const config = module_config.value.find((config) => config.variable === variable);
  // Log to the console, what the value was found
  if (config) {
    console.log(`Found value for ${variable}: ${config.value}`);
  } else {
    console.log(`No value found for ${variable}`);
  }
  return config ? config.value : '';
};

const onClickTestConnection = async () => {
  SessionUser.superUser.modules.xlvask.functions.testConnection().then((response) => {
    console.log(response);
    if (response.data.data) {
      Swal.fire({
        icon: 'success',
        title: 'Connection successful',
        text: 'The connection to the XLVask API was successful.',
      })
    }
  }).catch((error) => {
    console.log(error);
    Swal.fire({
      icon: 'error',
      title: 'Connection failed',
      text: 'The connection to the XLVask API failed.',
    })
  })
}

const load = async () => {
  await getModuleConfig();
};

load();

</script>

<template>
  <RestrictedPageWrapper :hasPermission="SessionUser.canAccessSuperUser()">
    <ConfigurationSubPageWrapper>
      <template #title>
        <PageTitle title="XLVask configuration" subtitle="The configuration of the XLVask integration" />
      </template>
      <template v-if="module_config.length > 0" #content>
        <ConfigurationCategory
          class="mt-2"
          module="XLVask"
          title="General settings"
          description="The general settings for the XLVask integration."
          icon="fas fa-cogs"
        >
        <ConfigurationSwitch
          class="mt-2"
          module="XLVask"
          title="Enable XLVask"
          description="Enable or disable the XLVask integration."
          icon="fas fa-cogs"
          :value="getModuleConfigValue('enabled') === true"
          :on-switch="SessionUser.superUser.modules.xlvask.config.enabled.set"
        />
        </ConfigurationCategory>
        <ConfigurationCategory
          class="mt-2"
          module="XLVask"
          title="API connection settings"
          description="The XLVask API connection settings."
          icon="fas fa-cogs"
        >
          <ConfigurationInput
              class="mt-2"
              module="XLVask"
              title="Username"
              description="The username is used to authenticate the API connection."
              icon="fas fa-cogs"
              v-bind:value="getModuleConfigValue('username')"
              :on-save="SessionUser.superUser.modules.xlvask.config.keys.username.set"
          />
          <ConfigurationSecretKey
            class="mt-2"
            module="XLVask"
            title="Password"
            description="The password is used to authenticate the API connection."
            icon="fas fa-cogs"
            :isSet="getModuleConfigValue('password') !== ''"
            :on-save="SessionUser.superUser.modules.xlvask.config.keys.password.set"
          />
        </ConfigurationCategory>
        <div class="buttons">
          <button class="button is-dark" @click="onClickTestConnection">
            <span class="icon">
              <i class="fas fa-sync"></i>
            </span>
            <span>Test connection</span>
          </button>
        </div>
      </template>
    </ConfigurationSubPageWrapper>
  </RestrictedPageWrapper>
</template>

<style scoped>

</style>